/*
SIGNATURE API

No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package signaturesapi

import (
	"bytes"
	"context"
	"io"
	"net/http"
	"net/url"
	"strings"
)


// InsignAPIService InsignAPI service
type InsignAPIService service

type ApiCreateInsignConfigurationRequest struct {
	ctx context.Context
	ApiService *InsignAPIService
	oid string
	createInsignConfigRequest *CreateInsignConfigRequest
}

func (r ApiCreateInsignConfigurationRequest) CreateInsignConfigRequest(createInsignConfigRequest CreateInsignConfigRequest) ApiCreateInsignConfigurationRequest {
	r.createInsignConfigRequest = &createInsignConfigRequest
	return r
}

func (r ApiCreateInsignConfigurationRequest) Execute() (*InsignConfiguration, *http.Response, error) {
	return r.ApiService.CreateInsignConfigurationExecute(r)
}

/*
CreateInsignConfiguration Create Insign configuration



 @param ctx context.Context - for authentication, logging, cancellation, deadlines, tracing, etc. Passed from http.Request or context.Background().
 @param oid Organization ID
 @return ApiCreateInsignConfigurationRequest
*/
func (a *InsignAPIService) CreateInsignConfiguration(ctx context.Context, oid string) ApiCreateInsignConfigurationRequest {
	return ApiCreateInsignConfigurationRequest{
		ApiService: a,
		ctx: ctx,
		oid: oid,
	}
}

// Execute executes the request
//  @return InsignConfiguration
func (a *InsignAPIService) CreateInsignConfigurationExecute(r ApiCreateInsignConfigurationRequest) (*InsignConfiguration, *http.Response, error) {
	var (
		localVarHTTPMethod   = http.MethodPost
		localVarPostBody     interface{}
		formFiles            []formFile
		localVarReturnValue  *InsignConfiguration
	)

	localBasePath, err := a.client.cfg.ServerURLWithContext(r.ctx, "InsignAPIService.CreateInsignConfiguration")
	if err != nil {
		return localVarReturnValue, nil, &GenericOpenAPIError{error: err.Error()}
	}

	localVarPath := localBasePath + "/integrations/insign/organizations/{oid}/configurations"
	localVarPath = strings.Replace(localVarPath, "{"+"oid"+"}", url.PathEscape(parameterValueToString(r.oid, "oid")), -1)

	localVarHeaderParams := make(map[string]string)
	localVarQueryParams := url.Values{}
	localVarFormParams := url.Values{}

	// to determine the Content-Type header
	localVarHTTPContentTypes := []string{"application/json"}

	// set Content-Type header
	localVarHTTPContentType := selectHeaderContentType(localVarHTTPContentTypes)
	if localVarHTTPContentType != "" {
		localVarHeaderParams["Content-Type"] = localVarHTTPContentType
	}

	// to determine the Accept header
	localVarHTTPHeaderAccepts := []string{"application/json"}

	// set Accept header
	localVarHTTPHeaderAccept := selectHeaderAccept(localVarHTTPHeaderAccepts)
	if localVarHTTPHeaderAccept != "" {
		localVarHeaderParams["Accept"] = localVarHTTPHeaderAccept
	}
	// body params
	localVarPostBody = r.createInsignConfigRequest
	req, err := a.client.prepareRequest(r.ctx, localVarPath, localVarHTTPMethod, localVarPostBody, localVarHeaderParams, localVarQueryParams, localVarFormParams, formFiles)
	if err != nil {
		return localVarReturnValue, nil, err
	}

	localVarHTTPResponse, err := a.client.callAPI(req)
	if err != nil || localVarHTTPResponse == nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	localVarBody, err := io.ReadAll(localVarHTTPResponse.Body)
	localVarHTTPResponse.Body.Close()
	localVarHTTPResponse.Body = io.NopCloser(bytes.NewBuffer(localVarBody))
	if err != nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	if localVarHTTPResponse.StatusCode >= 300 {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: localVarHTTPResponse.Status,
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	err = a.client.decode(&localVarReturnValue, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
	if err != nil {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: err.Error(),
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	return localVarReturnValue, localVarHTTPResponse, nil
}

type ApiDeleteInsignConfigurationRequest struct {
	ctx context.Context
	ApiService *InsignAPIService
	oid string
}

func (r ApiDeleteInsignConfigurationRequest) Execute() (*http.Response, error) {
	return r.ApiService.DeleteInsignConfigurationExecute(r)
}

/*
DeleteInsignConfiguration Delete Insign configuration



 @param ctx context.Context - for authentication, logging, cancellation, deadlines, tracing, etc. Passed from http.Request or context.Background().
 @param oid Organization ID
 @return ApiDeleteInsignConfigurationRequest
*/
func (a *InsignAPIService) DeleteInsignConfiguration(ctx context.Context, oid string) ApiDeleteInsignConfigurationRequest {
	return ApiDeleteInsignConfigurationRequest{
		ApiService: a,
		ctx: ctx,
		oid: oid,
	}
}

// Execute executes the request
func (a *InsignAPIService) DeleteInsignConfigurationExecute(r ApiDeleteInsignConfigurationRequest) (*http.Response, error) {
	var (
		localVarHTTPMethod   = http.MethodDelete
		localVarPostBody     interface{}
		formFiles            []formFile
	)

	localBasePath, err := a.client.cfg.ServerURLWithContext(r.ctx, "InsignAPIService.DeleteInsignConfiguration")
	if err != nil {
		return nil, &GenericOpenAPIError{error: err.Error()}
	}

	localVarPath := localBasePath + "/integrations/insign/organizations/{oid}/configurations"
	localVarPath = strings.Replace(localVarPath, "{"+"oid"+"}", url.PathEscape(parameterValueToString(r.oid, "oid")), -1)

	localVarHeaderParams := make(map[string]string)
	localVarQueryParams := url.Values{}
	localVarFormParams := url.Values{}

	// to determine the Content-Type header
	localVarHTTPContentTypes := []string{}

	// set Content-Type header
	localVarHTTPContentType := selectHeaderContentType(localVarHTTPContentTypes)
	if localVarHTTPContentType != "" {
		localVarHeaderParams["Content-Type"] = localVarHTTPContentType
	}

	// to determine the Accept header
	localVarHTTPHeaderAccepts := []string{}

	// set Accept header
	localVarHTTPHeaderAccept := selectHeaderAccept(localVarHTTPHeaderAccepts)
	if localVarHTTPHeaderAccept != "" {
		localVarHeaderParams["Accept"] = localVarHTTPHeaderAccept
	}
	req, err := a.client.prepareRequest(r.ctx, localVarPath, localVarHTTPMethod, localVarPostBody, localVarHeaderParams, localVarQueryParams, localVarFormParams, formFiles)
	if err != nil {
		return nil, err
	}

	localVarHTTPResponse, err := a.client.callAPI(req)
	if err != nil || localVarHTTPResponse == nil {
		return localVarHTTPResponse, err
	}

	localVarBody, err := io.ReadAll(localVarHTTPResponse.Body)
	localVarHTTPResponse.Body.Close()
	localVarHTTPResponse.Body = io.NopCloser(bytes.NewBuffer(localVarBody))
	if err != nil {
		return localVarHTTPResponse, err
	}

	if localVarHTTPResponse.StatusCode >= 300 {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: localVarHTTPResponse.Status,
		}
		return localVarHTTPResponse, newErr
	}

	return localVarHTTPResponse, nil
}

type ApiGetInsignConfigurationRequest struct {
	ctx context.Context
	ApiService *InsignAPIService
	oid string
}

func (r ApiGetInsignConfigurationRequest) Execute() (*InsignConfiguration, *http.Response, error) {
	return r.ApiService.GetInsignConfigurationExecute(r)
}

/*
GetInsignConfiguration Get Insign configuration



 @param ctx context.Context - for authentication, logging, cancellation, deadlines, tracing, etc. Passed from http.Request or context.Background().
 @param oid Organization ID
 @return ApiGetInsignConfigurationRequest
*/
func (a *InsignAPIService) GetInsignConfiguration(ctx context.Context, oid string) ApiGetInsignConfigurationRequest {
	return ApiGetInsignConfigurationRequest{
		ApiService: a,
		ctx: ctx,
		oid: oid,
	}
}

// Execute executes the request
//  @return InsignConfiguration
func (a *InsignAPIService) GetInsignConfigurationExecute(r ApiGetInsignConfigurationRequest) (*InsignConfiguration, *http.Response, error) {
	var (
		localVarHTTPMethod   = http.MethodGet
		localVarPostBody     interface{}
		formFiles            []formFile
		localVarReturnValue  *InsignConfiguration
	)

	localBasePath, err := a.client.cfg.ServerURLWithContext(r.ctx, "InsignAPIService.GetInsignConfiguration")
	if err != nil {
		return localVarReturnValue, nil, &GenericOpenAPIError{error: err.Error()}
	}

	localVarPath := localBasePath + "/integrations/insign/organizations/{oid}/configurations"
	localVarPath = strings.Replace(localVarPath, "{"+"oid"+"}", url.PathEscape(parameterValueToString(r.oid, "oid")), -1)

	localVarHeaderParams := make(map[string]string)
	localVarQueryParams := url.Values{}
	localVarFormParams := url.Values{}

	// to determine the Content-Type header
	localVarHTTPContentTypes := []string{}

	// set Content-Type header
	localVarHTTPContentType := selectHeaderContentType(localVarHTTPContentTypes)
	if localVarHTTPContentType != "" {
		localVarHeaderParams["Content-Type"] = localVarHTTPContentType
	}

	// to determine the Accept header
	localVarHTTPHeaderAccepts := []string{"application/json"}

	// set Accept header
	localVarHTTPHeaderAccept := selectHeaderAccept(localVarHTTPHeaderAccepts)
	if localVarHTTPHeaderAccept != "" {
		localVarHeaderParams["Accept"] = localVarHTTPHeaderAccept
	}
	req, err := a.client.prepareRequest(r.ctx, localVarPath, localVarHTTPMethod, localVarPostBody, localVarHeaderParams, localVarQueryParams, localVarFormParams, formFiles)
	if err != nil {
		return localVarReturnValue, nil, err
	}

	localVarHTTPResponse, err := a.client.callAPI(req)
	if err != nil || localVarHTTPResponse == nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	localVarBody, err := io.ReadAll(localVarHTTPResponse.Body)
	localVarHTTPResponse.Body.Close()
	localVarHTTPResponse.Body = io.NopCloser(bytes.NewBuffer(localVarBody))
	if err != nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	if localVarHTTPResponse.StatusCode >= 300 {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: localVarHTTPResponse.Status,
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	err = a.client.decode(&localVarReturnValue, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
	if err != nil {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: err.Error(),
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	return localVarReturnValue, localVarHTTPResponse, nil
}
